/*-
 * Copyright (c) 2002l Norikatsu Shigemura
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef	__LINUX_IOCTL__
#define	__LINUX_IOCTL__

#if	defined(__i386__)

#define	_LINUX_IOC_NRBITS	8
#define	_LINUX_IOC_TYPEBITS	8
#define	_LINUX_IOC_SIZEBITS	14
#define	_LINUX_IOC_DIRBITS	2

#else

#error	NOT SUPPORT ARCHITECTURE

#endif

#define	_LINUX_IOC_NRMASK	( (1 << _IOC_NRBITS  ) - 1)
#define	_LINUX_IOC_TYPEMASK	( (1 << _IOC_TYPEBITS) - 1)
#define	_LINUX_IOC_SIZEMASK	( (1 << _IOC_SIZEBITS) - 1)
#define	_LINUX_IOC_DIRMASK	( (1 << _IOC_DIRBITS ) - 1)

#define	_LINUX_IOC_NRSHIFT	0
#define	_LINUX_IOC_TYPESHIFT	(_LINUX_IOC_NRSHIFT   + _LINUX_IOC_NRBITS)
#define	_LINUX_IOC_SIZESHIFT	(_LINUX_IOC_TYPESHIFT + _LINUX_IOC_TYPEBITS)
#define	_LINUX_IOC_DIRSHIFT	(_LINUX_IOC_SIZESHIFT + _LINUX_IOC_SIZEBITS)

#define	_LINUX_IOC_NONE		0U
#define	_LINUX_IOC_WRITE	1U
#define	_LINUX_IOC_READ		2U

#define	_LINUX_IOC(dir, type, nr, size)		\
	(  ( (dir)  << _LINUX_IOC_DIRSHIFT  ) |	\
	   ( (type) << _LINUX_IOC_TYPESHIFT ) |	\
	   ( (nr)   << _LINUX_IOC_NRSHIFT   ) |	\
	   ( (size) << _LINUX_IOC_SIZESHIFT )  )

#define	_LINUX_IO(type, nr)			\
		_LINUX_IOC(_LINUX_IOC_NONE,                  (type), (nr), 0)
#define	_LINUX_IOR(type, nr, size)		\
		_LINUX_IOC(_LINUX_IOC_READ,                  (type), (nr), sizeof(size))
#define	_LINUX_IOW(type, nr, size)		\
		_LINUX_IOC(_LINUX_IOC_WRITE,                 (type), (nr), sizeof(size))
#define	_LINUX_IOWR(type, nr, size)		\
		_LINUX_IOC(_LINUX_IOC_READ|_LINUX_IOC_WRITE, (type), (nr), sizeof(size))


/******************************************************************************/

#if	0
typedef struct linux_audio_buf_info {
	int	fragments;
	int	fragstotal;
	int	fragsize;
	int	bytes;
} linux_audio_buf_info;
#else
/* XXX: assume to 'struct audio_buf_info' is same */
#define	linux_audio_buf_info	audio_buf_info
#endif

#define	LINUX_SNDCTL_DSP_RESET		_LINUX_IO  ('P',  0)
#define	LINUX_SNDCTL_DSP_SPEED		_LINUX_IOWR('P',  2, int)
#define	LINUX_SNDCTL_DSP_STEREO		_LINUX_IOWR('P',  3, int)
#define	LINUX_SNDCTL_DSP_GETBLKSIZE	_LINUX_IOWR('P',  4, int)
#define	LINUX_SNDCTL_DSP_SETFMT		_LINUX_IOWR('P',  5, int)
#define	LINUX_SNDCTL_DSP_SETFRAGMENT	_LINUX_IOWR('P', 10, int)
#define	LINUX_SNDCTL_DSP_GETOSPACE	_LINUX_IOR ('P', 12, linux_audio_buf_info)
#define	LINUX_SNDCTL_DSP_NONBLOCK	_LINUX_IO  ('P', 14)
#define	LINUX_SNDCTL_DSP_GETCAPS	_LINUX_IOR ('P', 15, int)

#define	DSP_DEVICE			"/dev/dsp"

#endif	/* __LINUX_IOCTL__ */
